//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%370BACAEF915.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%370BACAEF915.cm

//## begin module%370BACAEF915.cp preserve=no
//## end module%370BACAEF915.cp

//## Module: DataSet%370BACAEF915; Package specification
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/DataSet.h

#ifndef DATASET_H
#define DATASET_H 1

//## begin module%370BACAEF915.additionalIncludes preserve=no
//## end module%370BACAEF915.additionalIncludes

//## begin module%370BACAEF915.includes preserve=yes
#include "xsTypes.h"
//## end module%370BACAEF915.includes

// Error
#include <XSUtil/Error/Error.h>
// iosfwd
#include <iosfwd>
// FakeDataInputRecord
#include <XSModel/Data/FakeDataInputRecord.h>
// XspecRegistry
#include <XSModel/DataFactory/XspecRegistry.h>

class DataSetBase;
//## Modelname: XSModel::GlobalContainer%3E42929A0210
namespace XSContainer {
    class DataContainer;

} // namespace XSContainer

//## begin module%370BACAEF915.declarations preserve=no
//## end module%370BACAEF915.declarations

//## begin module%370BACAEF915.additionalDeclarations preserve=yes
class DataInputRecord;
//## end module%370BACAEF915.additionalDeclarations


//## begin DataSet%362CB3E90259.preface preserve=yes
//## end DataSet%362CB3E90259.preface

//## Class: DataSet%362CB3E90259; Abstract; protected
//	A data set is the basic data unit consisting of a
//	spectrum expressed in counts per energy bin
//	The data set "uses" a response file, an  efficiency file,
//	an optional correction file and an optional background
//	file
//	The plan is to implement as data members raw i.e. as read
//	data sets to speed up the ignore/notice commands etc.
//	This superclass provides the general interface of the
//	data to the rest of the program. The subclasses are
//	different formats that overload the read() function.
//## Category: XSModel::Data%36349D4100F3
//## Subsystem: XSModel::Data%367691B49E40
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A2BB30D01CE;SpectralData { -> }
//## Uses: <unnamed>%3AA908500143;XSContainer::DataContainer { -> F}
//## Uses: <unnamed>%3C34A83A00E0;XSContainer::SpectralDataMap { -> }
//## Uses: <unnamed>%3E94767D0052;YellowAlert { -> }
//## Uses: <unnamed>%47C484150371;FakeDataInputRecord { -> }

class DataSet : public RegisteredFormat  //## Inherits: <unnamed>%399967380180
{
  //## begin DataSet%362CB3E90259.initialDeclarations preserve=yes
  //## end DataSet%362CB3E90259.initialDeclarations

  public:
    //## Class: AbortDataLoop%3A5CCAAB019F
    //	Exception to be thrown on receiving an abort sequence,
    //	usually via user entry of the "none" or "/*" sequence.
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class AbortDataLoop : public YellowAlert  //## Inherits: <unnamed>%3A5CCB7A03AF
    {
      public:
        //## Constructors (specified)
          //## Operation: AbortDataLoop%3A5CCAEE0255
          AbortDataLoop (const string& msg = "Terminated at user request\n");

      protected:
      private:
      private: //## implementation
    };

    //## Class: ResponseIsNeeded%3E947431015B
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class ResponseIsNeeded : public YellowAlert  //## Inherits: <unnamed>%3E94745E015E
    {
      public:
        //## Constructors (specified)
          //## Operation: ResponseIsNeeded%3E9476B90159
          ResponseIsNeeded (const string& msg = "");

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (generated)
      DataSet();

      DataSet(const DataSet &right);

    //## Destructor (generated)
      virtual ~DataSet();

    //## Assignment Operation (generated)
      DataSet & operator=(const DataSet &right);


    //## Other Operations (specified)
      //## Operation: plot%3860E0D78530
      void plot (const string& args);

      //## Operation: clone%39940F2A02D9
      virtual DataSet* clone () const = 0;

      //## Operation: groupingInfo%39F84FF702CD
      const std::vector<int>& groupingInfo (size_t row) const;

      //## Operation: qualityInfo%39F8503A0166
      const std::vector<int>& qualityInfo (size_t row) const;

      //## Operation: channels%39F87CED027F
      size_t channels (size_t row) const;

      //## Operation: dataName%39F88AF0007F
      const string& dataName () const;

      //## Operation: sourceData%3A2BDB0C0394
      SpectralData*& sourceData (size_t row);

      //## Operation: initialize%3A1C10AA028C
      virtual void initialize (DataPrototype* proto, DataInputRecord& record) = 0;

      //## Operation: setData%3A22A6A902E7
      //	setData processes the input file for a single source
      //	spectrum into a data object (e.g. SpectrumData,
      //	ResponseData). For files with multiple sources,
      //	e.g. OGIP type II files, setData will be called once for
      //	each data row to be read.
      void setData (size_t spectrumNumber, size_t row = 0);

      //## Operation: setResponse%3A35417C03DC
      //	setData processes the input file for a single source
      //	spectrum into a data object (e.g. SpectrumData,
      //	ResponseData). For files with multiple sources,
      //	e.g. OGIP type II files, setData will be called once for
      //	each data row to be read.
      virtual void setResponse (size_t spectrumNumber, size_t row = 0);

      //## Operation: ignoreBadChannels%3BBCD7B801D7
      void ignoreBadChannels ();

      //## Operation: report%3A2E71320004
      virtual void report (size_t row) const;

      //## Operation: destroy%3A36436C027B
      //## Exceptions: ()
      void destroy () throw ();

      //## Operation: reportAll%3A378D1000FC
      virtual void reportAll ();

      //## Operation: sourceData%3A3794B3018C
      const SpectralData* sourceData (size_t row) const;

      //## Operation: closeSourceFiles%3A393F0A036C
      virtual void closeSourceFiles () = 0;

      //## Operation: isMultiple%3A394B560027
      virtual bool isMultiple () const;

      //## Operation: numSpectra%3A3A652E018A
      int numSpectra () const;

      //## Operation: legalChannelBounds%3A48DE0100AE
      //	return TLMINn, TLMAXn for the file, which are the start
      //	and end range of rows in which  the response data may be
      //	contained.
      void legalChannelBounds (int& startChan, int& endChan) const;

      //## Operation: groupingSet%3A59E2F103B3
      bool groupingSet (size_t row);

      //## Operation: qualitySet%3A59E3E3015C
      bool qualitySet (size_t row);

      //## Operation: dataGroup%3AAE558401A4
      size_t dataGroup () const;

      //## Operation: dataGroup%3AAE55AA0248
      void dataGroup (size_t group);

      //## Operation: operator<%3BB20748008B
      friend bool operator < (const DataSet& left, const DataSet& right);

      //## Operation: operator!=%3BB207D101D5
      friend bool operator != (const DataSet& left, const DataSet& right);

      //## Operation: operator==%3BB207EC01A7
      friend bool operator == (const DataSet& left, const DataSet& right);

      //## Operation: operator>%3BB2081F0216
      friend bool operator > (const DataSet& left, const DataSet& right);

      //## Operation: index%3BB2093F03CA
      size_t index () const;

      //## Operation: removeNumberedSpectrum%3C1FD05201FC
      int removeNumberedSpectrum (size_t index, bool remove = false);

      //## Operation: setChannels%3BBE174E0003
      void setChannels (bool value, IntegerArray& channelRange);

      //## Operation: setChannels%3BD95A850132
      void setChannels (bool value, std::pair<Real,Real>& realRange	// for setting energy or wavelength range ignore/notice
      	// status
      );

      //## Operation: reportResponse%3C03FC6100FA
      virtual void reportResponse (size_t row) const = 0;

      //## Operation: spectralData%3C1FCBFA01C3
      SpectralData* spectralData () const;

      //## Operation: multiSpectralData%3C1FCC3802A2
      const std::map<size_t,SpectralData*>& multiSpectralData () const;

      //## Operation: origNumSources%3C76A99301B8
      int origNumSources () const;

      //## Operation: origNumSources%3C76A9BA011E
      void origNumSources (int value);

      //## Operation: setResponse%3CD69E3800CA
      virtual bool setResponse (SpectralData* sourceSpectrum, size_t spectrumNumber, size_t sourceNum, const string& responseName, const string& arfName);

      //## Operation: setBackgroundData%3D1CACBC0231
      virtual bool setBackgroundData (size_t row, int bckRow);

      //## Operation: setCorrectionData%3D1CAD1300A3
      virtual bool setCorrectionData (size_t row, int corRow);

      //## Operation: resetAllDetectors%3E7247E1018F
      bool resetAllDetectors ();

      //## Operation: initializeFake%3E89E3AF0316
      virtual void initializeFake (DataPrototype* proto, FakeDataInputRecord& record) = 0;

      //## Operation: outputData%3E9D8C4602D0
      virtual void outputData () = 0;

      //## Operation: nullBackPointers%3EA02D9F02B6
      void nullBackPointers (const IntegerArray& rows);

      //## Operation: specNumOrder%3EA954220206
      bool specNumOrder (IntegerArray& rows) const;

      //## Operation: getResponseName%3EB918FA024A
      virtual FakeDataInputRecord::Detectors getResponseName (size_t rowNum) const = 0;

      //## Operation: getAncillaryLocation%3EB967BF0337
      virtual FakeDataInputRecord::Arfs getAncillaryLocation (size_t rowNum, const FakeDataInputRecord::Detectors& respInfo) const = 0;

      //## Operation: getBackCorrLocation%3EB968640374
      virtual std::pair<string,size_t> getBackCorrLocation (size_t rowNum, bool isCorr = false) const = 0;

      //## Operation: generateFake%3ED4D8AE02B2
      virtual void generateFake ();

      //## Operation: outputFileName%3EDCC2DC0298
      const string& outputFileName () const;

      //## Operation: outputFileName%3EDCC311014C
      void outputFileName (const string& fileName);

      //## Operation: outputBckFileName%3EDCEB230106
      const string& outputBckFileName () const;

      //## Operation: outputBckFileName%3EDCEB6502CF
      void outputBckFileName (const string& fileName);

      //## Operation: getMaxChannels%3EDD15BD0080
      size_t getMaxChannels () const;

      //## Operation: isModular%3EE8850200B1
      virtual bool isModular () const;

      //## Operation: setModelNamesForFake%3EFB64F00133
      void setModelNamesForFake (const string& name, size_t index);

      //## Operation: setModelNamesForFake%3EFC854A0025
      void setModelNamesForFake (const StringArray& names);

      //## Operation: anyQuality%3F74811501CE
      bool anyQuality () const;

      //## Operation: anyGrouping%3F74815A002B
      bool anyGrouping () const;

      //## Operation: aScaleIsKeyword%3F7C76D5003C
      bool aScaleIsKeyword () const;

      //## Operation: bScaleIsKeyword%3F7C772002E9
      bool bScaleIsKeyword () const;

      //## Operation: getFullPathName%3F983B1E0388
      string getFullPathName () const;

      //## Operation: setRunPath%3F992588017C
      void setRunPath ();

      //## Operation: getRunPath%41925EA0037D
      const string& getRunPath () const;

      //## Operation: STD_FIRST_CHAN%41C9F025028A
      static size_t STD_FIRST_CHAN ();

      //## Operation: insertSpectrum%41FA8E2A00B0
      void insertSpectrum (SpectralData* s);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: useFakeCountingStat%3EDCAA3702D7
      static bool useFakeCountingStat ();
      static void useFakeCountingStat (bool value);

      //## Attribute: xspecVersion%3EFC609F030B
      static const string& xspecVersion ();
      static void xspecVersion (const string& value);

  public:
    // Additional Public Declarations
      //## begin DataSet%362CB3E90259.public preserve=yes
      //## end DataSet%362CB3E90259.public

  protected:

    //## Other Operations (specified)
      //## Operation: Swap%39E3870302E7
      virtual void Swap (DataSet& right);

      //## Operation: setAncillaryData%3A27C5FB034A
      virtual bool setAncillaryData (size_t row, int ancRow = -1) = 0;

      //## Operation: setArrays%3A2BAA470180
      virtual void setArrays (size_t row = 0) = 0;

      //## Operation: scaleArrays%3A2BAA5702CE
      virtual void scaleArrays (size_t row = 0);

      //## Operation: setDescription%3A2BAA7102BA
      virtual void setDescription (size_t spectrumNum = 1, size_t row = 0) = 0;

      //## Operation: isCounts%3A366F3100E0
      virtual bool isCounts () const;

      //## Operation: computeTotals%3A378ECB022B
      virtual void computeTotals (size_t row);

      //## Operation: dataSetBase%3A3793B10102
      const DataSetBase* dataSetBase () const;

      //## Operation: groupArrays%3C51AB9001AE
      virtual void groupArrays (size_t row);

      //## Operation: isNet%3FD88DBD0209
      virtual bool isNet (const RealArray& spectrum);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: count%39E35E1502F6
      static const int count ();

    //## Get and Set Operations for Associations (generated)

      //## Association: Opaque Pointer%3AA906BB0132
      //## Role: DataSet::dataSetBase%3AA906BC0084
      DataSetBase*& dataSetBase ();

    // Additional Protected Declarations
      //## begin DataSet%362CB3E90259.protected preserve=yes
      //## end DataSet%362CB3E90259.protected

  private:

    //## Other Operations (specified)
      //## Operation: copy%3A9578220288
      virtual void copy (const DataSet& right) = 0;

    // Additional Private Declarations
      //## begin DataSet%362CB3E90259.private preserve=yes
      //## end DataSet%362CB3E90259.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin DataSet::count%39E35E1502F6.attr preserve=no  protected: static int {U} 
      static int s_count;
      //## end DataSet::count%39E35E1502F6.attr

      //## begin DataSet::useFakeCountingStat%3EDCAA3702D7.attr preserve=no  public: static bool {U} 
      static bool s_useFakeCountingStat;
      //## end DataSet::useFakeCountingStat%3EDCAA3702D7.attr

      //## begin DataSet::xspecVersion%3EFC609F030B.attr preserve=no  public: static string {U} 
      static string s_xspecVersion;
      //## end DataSet::xspecVersion%3EFC609F030B.attr

      //## Attribute: STD_FIRST_CHAN%41C9EFE0003E
      //## begin DataSet::STD_FIRST_CHAN%41C9EFE0003E.attr preserve=no  public: static const size_t {U} 1
      static const size_t s_STD_FIRST_CHAN;
      //## end DataSet::STD_FIRST_CHAN%41C9EFE0003E.attr

    // Data Members for Associations

      //## Association: Opaque Pointer%3AA906BB0132
      //## begin DataSet::dataSetBase%3AA906BC0084.role preserve=no  protected: DataSetBase { -> 1RFHgN}
      DataSetBase* m_dataSetBase;
      //## end DataSet::dataSetBase%3AA906BC0084.role

    // Additional Implementation Declarations
      //## begin DataSet%362CB3E90259.implementation preserve=yes
      friend class DataContainer;
      //## end DataSet%362CB3E90259.implementation
};

//## begin DataSet%362CB3E90259.postscript preserve=yes
//## end DataSet%362CB3E90259.postscript

// Class DataSet::AbortDataLoop 

// Class DataSet::ResponseIsNeeded 

// Class DataSet 


//## Other Operations (inline)
inline const DataSetBase* DataSet::dataSetBase () const
{
  //## begin DataSet::dataSetBase%3A3793B10102.body preserve=yes
  //## end DataSet::dataSetBase%3A3793B10102.body

  return m_dataSetBase;
}

inline bool DataSet::isModular () const
{
  //## begin DataSet::isModular%3EE8850200B1.body preserve=yes
  return false;
  //## end DataSet::isModular%3EE8850200B1.body
}

inline size_t DataSet::STD_FIRST_CHAN ()
{
  //## begin DataSet::STD_FIRST_CHAN%41C9F025028A.body preserve=yes
  return s_STD_FIRST_CHAN;
  //## end DataSet::STD_FIRST_CHAN%41C9F025028A.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const int DataSet::count ()
{
  //## begin DataSet::count%39E35E1502F6.get preserve=no
  return s_count;
  //## end DataSet::count%39E35E1502F6.get
}

inline bool DataSet::useFakeCountingStat ()
{
  //## begin DataSet::useFakeCountingStat%3EDCAA3702D7.get preserve=no
  return s_useFakeCountingStat;
  //## end DataSet::useFakeCountingStat%3EDCAA3702D7.get
}

inline void DataSet::useFakeCountingStat (bool value)
{
  //## begin DataSet::useFakeCountingStat%3EDCAA3702D7.set preserve=no
  s_useFakeCountingStat = value;
  //## end DataSet::useFakeCountingStat%3EDCAA3702D7.set
}

inline const string& DataSet::xspecVersion ()
{
  //## begin DataSet::xspecVersion%3EFC609F030B.get preserve=no
  return s_xspecVersion;
  //## end DataSet::xspecVersion%3EFC609F030B.get
}

inline void DataSet::xspecVersion (const string& value)
{
  //## begin DataSet::xspecVersion%3EFC609F030B.set preserve=no
  s_xspecVersion = value;
  //## end DataSet::xspecVersion%3EFC609F030B.set
}

//## Get and Set Operations for Associations (inline)

inline DataSetBase*& DataSet::dataSetBase ()
{
  //## begin DataSet::dataSetBase%3AA906BC0084.get preserve=no
  return m_dataSetBase;
  //## end DataSet::dataSetBase%3AA906BC0084.get
}

//## begin module%370BACAEF915.epilog preserve=yes
//## end module%370BACAEF915.epilog


#endif
